#!/usr/bin/env ruby

if $0 == "gtesttree.rb"
  require 'gnewt'
else
  require 'newt'
end

include Newt

init
cls

checktree = CheckboxTree.new(-1, -1, 10, FLAG_SCROLL, " ab")
checktree.AddItem ("Numbers", 2, 0, ARG_APPEND)
checktree.AddItem ("Really really long thing", 3, 0, ARG_APPEND)
checktree.AddItem ("number 5", 5, FLAG_SELECTED, ARG_APPEND)
checktree.AddItem ("number 6", 6, 0, ARG_APPEND)
checktree.AddItem ("number 7", 7, FLAG_SELECTED, ARG_APPEND)
checktree.AddItem ("number 8", 8, 0, ARG_APPEND)
checktree.AddItem ("number 9", 9, 0, ARG_APPEND)
checktree.AddItem ("number 10", 10, FLAG_SELECTED, ARG_APPEND)
checktree.AddItem ("number 11", 11, 0, ARG_APPEND)
checktree.AddItem ("Donuts", 12, FLAG_SELECTED, ARG_APPEND)
checktree.AddItem ("Bavarian Cream", 301, FLAG_SELECTED, 9, ARG_APPEND)
checktree.AddItem ("Honey dipped", 302, FLAG_SELECTED, 9, ARG_APPEND)
checktree.AddItem ("Jelly", 303, FLAG_SELECTED, 9, ARG_APPEND)
checktree.AddItem ("Colors", 1, 0, 0)
checktree.AddItem ("Red", 100, 0, 0, ARG_APPEND)
checktree.AddItem ("White", 101, 0, 0, ARG_APPEND)
checktree.AddItem ("Blue", 102, 0, 0, ARG_APPEND)
checktree.AddItem ("number 4", 4, 0, 3)
checktree.AddItem ("Single digit", 200, 0, 1, ARG_APPEND)
checktree.AddItem ("One", 201, 0, 1, 0, ARG_APPEND)
checktree.AddItem ("Two", 202, 0, 1, 0, ARG_APPEND)
checktree.AddItem ("Three", 203, 0, 1, 0, ARG_APPEND)
checktree.AddItem ("Four", 204, 0, 1, 0, ARG_APPEND)
checktree.AddItem ("Double digit", 300, 0, 1, ARG_APPEND)
checktree.AddItem ("Ten", 210, 0, 1, 1, ARG_APPEND)
checktree.AddItem ("Eleven", 211, 0, 1, 1, ARG_APPEND)
checktree.AddItem ("Twelve", 212, 0, 1, 1, ARG_APPEND)
checktree.AddItem ("Thirteen", 213, 0, 1, 1, ARG_APPEND)

checktree.SetCurrent (12)

button = Button.new (-1, -1, "Exit")
grid = Grid.new (1, 2);
grid.SetField (0, 0, GRID_COMPONENT, checktree, 0, 0, 0, 1, ANCHOR_RIGHT, 0)
grid.SetField (0, 1, GRID_COMPONENT, button, 0, 0, 0, 0, 0, 0);

grid.WrappedWindow ("Checkbox Tree Test")
grid.Free (1)

form = Form.new
form.AddComponents (checktree, button)
form.Run

result1 = checktree.GetSelection
result2 = checktree.GetMultiSelection ("b")
result3 = checktree.FindItem (213)

finished

form.Destroy

print "Current selection (all) (#{result1.length}):\n"
result1.each do |v|
  print v, "\n"
end
print "Current selection (b) (#{result2.length}):\n"
result2.each do |v|
  print v, "\n"
end
print "path:"
result3.each do |v|
  print " #{v}"
end
print "\n"
